import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;

import com.java4less.vision.Barcode1DReader;
import com.java4less.vision.BarcodeData;
import com.java4less.vision.RImage;



public class Sample {
	
	private String[][] testSet={{"ima_300dpi_90.png",""+Barcode1DReader.CODE128},
{"ean128_5_4.png",""+Barcode1DReader.CODE128},
{"ean128_90_2.png",""+Barcode1DReader.CODE128},
{"ean128_90_1.GIF",""+Barcode1DReader.CODE128},
{"ean128_266_3.png",""+Barcode1DReader.CODE128},
{"ean128_111_3.png",""+Barcode1DReader.CODE128}, 
{"ean128_10_2.png",""+Barcode1DReader.CODE128},
{"ean128_0_2.png",""+Barcode1DReader.CODE128},	
{"ean128_45_4.png",""+Barcode1DReader.CODE128},	
{"ean128_45_3.png",""+Barcode1DReader.CODE128},	
{"ean128_30_3.png",""+Barcode1DReader.CODE128},
{"ean128_60_3.png",""+Barcode1DReader.CODE128},	
{"ean13_0_3.png",""+Barcode1DReader.EAN13},	
{"ean8.png",""+Barcode1DReader.EAN8},	
{"upca.png",""+Barcode1DReader.UPCA},	
{"upce.png",""+Barcode1DReader.UPCE},	
{"upce_2.png",""+Barcode1DReader.UPCE},	
{"code39.png",""+Barcode1DReader.CODE39},
{"scan_ean1.gif",""+Barcode1DReader.EAN13},
{"scan_ean2.png",""+Barcode1DReader.EAN13},
{"identcode.PNG",""+Barcode1DReader.IDENTCODE},
{"scan_ean4.png",""+Barcode1DReader.EAN13},
{"ean13_shoe.png",""+Barcode1DReader.EAN13},
{"ean8_scan1_2.png",""+Barcode1DReader.EAN8},
{"ean8_bag.png",""+Barcode1DReader.EAN8},
{"i25.png",""+Barcode1DReader.INTERLEAVED25},
{"barcode_scan7_i125.png",""+Barcode1DReader.INTERLEAVED25},
{"barcode_scan3_code128.png",""+Barcode1DReader.CODE128},
{"barcode_scan5_ean13.png",""+Barcode1DReader.EAN13},
{"barcode_scan_code39.png",""+Barcode1DReader.CODE39}};

	
	private String dir="images\\";
	
	public static void main(String[] args)  {
	
		Sample sample=new Sample();
		try {
			
			//sample.scanImage("identcode.PNG",Barcode1DReader.IDENTCODE);
			/*sample.scanImage("scan_ean4.png",Barcode1DReader.EAN8 | Barcode1DReader.EAN13 );
			sample.scanImage("ean13_shoe.png",Barcode1DReader.EAN8 | Barcode1DReader.EAN13 );
			sample.scanImage("barcode_scan7_i125.png",Barcode1DReader.INTERLEAVED25);			
			sample.scanImage("ean8_bag.png",Barcode1DReader.EAN8 | Barcode1DReader.EAN13 );
			sample.scanImage("barcode_scan3_code128.png",Barcode1DReader.CODE128 | Barcode1DReader.EAN13 );
			sample.scanImage("ean128_90_1.GIF",Barcode1DReader.CODE128 );
			*/			
			
			sample.runTests();
		} catch (Exception e) {

			e.printStackTrace();
		}
		
	}
	
	/**
	 * read all test files
	 *
	 */
	public void runTests() {		
		for (int i=0;i<testSet.length;i++) {
			try {
				
				System.out.println("");
				System.out.println("------------------------------");
				System.out.println("Scanning File: "+testSet[i][0]);
				System.out.println("");
				scanImage(testSet[i][0],new Integer(testSet[i][1]).intValue());
				System.out.println("------------------------------");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}		
	}
	
	/**
	 * scan file
	 * @param file image file
	 * @param type type of expected barcode
	 * @throws Exception
	 */
	public void scanImage(String file,int type) throws Exception {
		
		Image im=loadImage(dir+file);
		
		Barcode1DReader reader=new Barcode1DReader();
		reader.setSymbologies(type);
		
		long prv=System.currentTimeMillis();
		
		RImage rim=new RImage((BufferedImage) im);

        long tim=System.currentTimeMillis();
		BarcodeData[] barcodes=reader.scan(rim);
		rim=null;
		im=null;
		
		System.out.print("End. "+(System.currentTimeMillis()-tim)+". ");
		if (barcodes.length==0) System.out.println("*** NO BARCODE FOUND ***");
		
		for (int i=0;i<barcodes.length;i++) {
			System.out.println("Barcode  found "+barcodes[i].toString());
			
		}
						
	}
	
	/**
	 * load image from file
	 * @param f
	 * @return
	 * @throws Exception
	 */
	public Image loadImage(String f) throws Exception {
			Image im2=null;
			java.awt.MediaTracker mt2=null;

			java.io.FileInputStream in=null;
			byte[] b=null;
			int size=0;


			in=new java.io.FileInputStream( f);
			if (in!=null) {
				size=in.available();
				b=new byte[size];
				in.read(b);
				im2=java.awt.Toolkit.getDefaultToolkit().createImage(b);
				in.close();
			}

			mt2 = new java.awt.MediaTracker(new Canvas());		
			if (im2!=null) {
				if (mt2!=null) {mt2.addImage(im2,0); mt2.waitForID(0);}
				int WidthIm = im2.getWidth(null);
			}


		BufferedImage input=new BufferedImage(im2.getWidth(null),im2.getHeight(null),BufferedImage.TYPE_INT_ARGB);
		
		Graphics g=input.createGraphics();
		g.setColor(Color.white);
		g.fillRect(0,0,im2.getWidth(null),im2.getHeight(null));
		g.drawImage(im2,0,0,null);
		g.dispose();
		g=null;
		
		return input;


		}	

}
